import tkinter as tk

class MainWin(tk.Tk):
    struments = ['basso', 'chitarra', 'piano', 'sax']
    freqs = ['bassi', 'medio bassi', 'medi', 'medi superiori', 'alti']
    def __init__(self):
        super().__init__()
        self.index = 0
        self.populate()

    def populate(self):
        self.title('Esempio per Fabio75')
        st_pnl = tk.LabelFrame(self, text=' Strumenti ')
        st_pnl.grid(row=0, column=0, sticky='ns')
        self.v_scales = []
        self.h_scales = []
        for i in range(len(self.struments)):
            cnv = tk.Canvas(st_pnl, width=12, height=50)
            cnv.grid(row=0, column=i, padx=10, pady=10)
            cnv.create_text(6, 25, text=self.struments[i], angle=90, anchor='center')
            #sc = tk.Scale(st_pnl, from_=0, to=100, showvalue=False, orient=tk.VERTICAL, command=self.on_struments)
            sc = tk.Scale(st_pnl, from_=0, to=100, showvalue=False, orient=tk.VERTICAL)
            sc.bind("<ButtonRelease>", self.on_struments)
            sc.grid(row=1, column=i, padx=10, pady=10, sticky='nsew')
            st_pnl.grid_columnconfigure(i, weight=1)
            self.v_scales.append(sc)
        st_pnl.grid_rowconfigure(1, weight=1)
        fr_pnl = tk.LabelFrame(self, text=' Frequenze')
        fr_pnl.grid(row=0, column=1, sticky='ew')
        for i in range(len(self.freqs)):
            lbl = tk.Label(fr_pnl, text=self.freqs[i])
            lbl.grid(row=i, column=0, padx=10, pady=10)
            sc = tk.Scale(fr_pnl, from_=0, to=100, showvalue=False, orient=tk.HORIZONTAL)
            sc.bind("<ButtonRelease>", self.on_frequences)
            sc.grid(row=i, column=1, padx=10, pady=10, sticky='nsew')
            self.h_scales.append(sc)
        fr_pnl.grid_columnconfigure(1, weight=1)
        val_pnl = tk.LabelFrame(self, text=' Valori selezionati ')
        val_pnl.grid(row=2, column=0, columnspan=2, sticky='ew')
        lbl = tk.Label(val_pnl, text='Strumento', font='bold')
        lbl.grid(row=0, padx=10, pady=10, column=0)
        lbl = tk.Label(val_pnl, text='Volume', font='bold')
        lbl.grid(row=0, padx=10, pady=10, column=1)
        for i in range(len(self.freqs)):
            lbl = tk.Label(val_pnl, text=self.freqs[i], font='bold')
            lbl.grid(row=0, column=i+2, padx=10, pady=10)
        self.lst_val = []
        row = 1
        for s in self.struments:
            lbl = tk.Label(val_pnl, text=s)
            lbl.grid(row=row, column=0, padx=10, pady=10)
            l_row = []
            lbl = tk.Label(val_pnl, text='', width=4, relief='sunken')
            lbl.grid(row=row, column=1, padx=10, pady=10)
            l_row.append(lbl)
            for i in range(len(self.freqs)):
                lbl = tk.Label(val_pnl, text='', width=4, relief='sunken')
                lbl.grid(row=row, column=i+2, padx=10, pady=10)
                l_row.append(lbl)
            self.lst_val.append(l_row)
            row += 1
        for i in range(len(self.freqs)+2):
            val_pnl.grid_columnconfigure(i, weight=1, uniform='a')

        self.grid_columnconfigure(1, weight=1)

    def on_struments(self, evt):
        w = evt.widget
        try:
            index = self.v_scales.index(w)
            value = w.get()
        except ValueError:
            return
        self.index = index
        self.lst_val[self.index][0].configure(text=value)
        
        
    def on_frequences(self, evt):
        w = evt.widget
        try:
            index = self.h_scales.index(w)
            value = w.get()
        except ValueError:
            return
        self.lst_val[self.index][index+1].configure(text=value)


if __name__ == '__main__':
    app = MainWin()
    app.mainloop()
